/*
Created by: X
http://www.createdbyx.com/

This work is licensed under a Creative Commons Attribution-Noncommercial-Share Alike 2.5 Canada License 
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/. 
Permissions beyond the scope of this license may be available at http://contact.createdbyx.com/.
*/
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace XNAVisies_Example1
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            // TODO: use this.Content to load your game content here
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // TODO: Add your update logic here

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            // set a breakpoint on the line of code below and stepinto the method. Then hover your mouse over the value
            // varible after the varible is initilized. You can then see the visualizer by selecting the" XNAVisies: <name> Visulizer"
            // from the visualizer dropdown menu.
            this.DoColorTest();
            this.DoMatrixTest();
            this.DoTextureTest();
            this.DoRenderTargetTest();

            base.Draw(gameTime);
        }

        private void DoRenderTargetTest()
        {
            RenderTarget2D target;
            target = new RenderTarget2D(this.GraphicsDevice, 512, 512, 0, SurfaceFormat.Color, MultiSampleType.None, 0, RenderTargetUsage.PreserveContents);
            this.GraphicsDevice.SetRenderTarget(0, target);
            this.GraphicsDevice.Clear(Color.Green);
            this.spriteBatch.Begin();
            Texture2D value = this.Content.Load<Texture2D>("Wallpaper2");
            this.spriteBatch.Draw(value, new Rectangle(0, 0, 512, 512), Color.White);
            value = this.Content.Load<Texture2D>("biohaz");
            this.spriteBatch.Draw(value, new Rectangle(0, 0, 512, 512), Color.White);
            this.spriteBatch.End();
            this.GraphicsDevice.SetRenderTarget(0, null);
            // set the breakpoint at the end of this method body and then inspect the target varible with the 
            // RenderTarget2D visualizer
        }

        private void DoTextureTest()
        {
            Texture2D value = this.Content.Load<Texture2D>("Wallpaper2");
            value = this.Content.Load<Texture2D>("biohaz");
        }

        private void DoMatrixTest()
        {
            Matrix mat = Matrix.Identity;
        }

        private void DoColorTest()
        {
            Color value = new Color(255, 128, 64, 255);
        }
    }
}
