﻿/*
Created by: X
http://www.createdbyx.com/

This work is licensed under a Creative Commons Attribution-Noncommercial-Share Alike 2.5 Canada License 
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/. 
Permissions beyond the scope of this license may be available at http://contact.createdbyx.com/.
*/
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.VisualStudio.DebuggerVisualizers;
using Microsoft.Xna.Framework.Graphics;

[assembly: DebuggerVisualizer(typeof(XNAVisies.ColorVisualizer), Target = typeof(Microsoft.Xna.Framework.Graphics.Color), Description = "XNAVisies: Color Visualizer")]

namespace XNAVisies
{
    // TODO: Add the following to SomeType's definition to see this visualizer when debugging instances of SomeType:
    //
    // [DebuggerVisualizer(typeof(MatrixVisualizer))]
    // [Serializable]
    // public class SomeType
    // {
    // ...
    // }
    //
    /// <summary>
    /// A Visualizer for SomeType.
    /// </summary>
    public class ColorVisualizer : DialogDebuggerVisualizer
    {

        protected override void Show(IDialogVisualizerService windowService, IVisualizerObjectProvider objectProvider)
        {
            try
            {

            // TODO: Get the object to display a visualizer for.
            // Cast the result of objectProvider.GetObject()
            // to the type of the object being visualized.
            Color Col = (Color)objectProvider.GetObject();



            // TODO: Display your view of the object.
            // Replace displayForm with your own custom Form or Control.
            using (ColorVisualizerForm displayForm = new ColorVisualizerForm())
            {

                // assign the matrix
                displayForm.Color = Col;
                displayForm.OriginalColor = Col;

                if (windowService.ShowDialog(displayForm) == DialogResult.OK)
                {
                    try
                    {
                        // update object values
                        objectProvider.ReplaceObject(displayForm.Color);
                    }
                    catch (Exception)
                    {
                        MessageBox.Show(displayForm, "Could not set the color value.");
                    }
                }
            }
            }
            catch (Exception ex)
            {
                MessageBox.Show( "An unexpected error occoured!\r\n\r\n" + ex.Message + "\r\n\r\n" + ex.StackTrace , "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        // TODO: Add the following to your testing code to test the visualizer:
        //
        // MatrixVisualizer.TestShowVisualizer(new SomeType());
        //
        /// <summary>
        /// Tests the visualizer by hosting it outside of the debugger.
        /// </summary>
        /// <param name="objectToVisualize">The object to display in the visualizer.</param>
        public static void TestShowVisualizer(object objectToVisualize)
        {
            VisualizerDevelopmentHost visualizerHost = new VisualizerDevelopmentHost(objectToVisualize, typeof(ColorVisualizer));
            visualizerHost.ShowVisualizer();
        }
    }
}
