﻿/*
Created by: X
http://www.createdbyx.com/

This work is licensed under a Creative Commons Attribution-Noncommercial-Share Alike 2.5 Canada License 
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/. 
Permissions beyond the scope of this license may be available at http://contact.createdbyx.com/.
*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Color = Microsoft.Xna.Framework.Graphics.Color;

namespace XNAVisies
{
    public partial class ColorVisualizerForm : Form
    {
        private Color mobjColor;

        public Color OriginalColor
        {
            get { return mobjColor; }
            set { mobjColor = value; }
        }

        public Color Color
        {
            get { return new Color((byte)nudRed.Value, (byte)nudGreen.Value, (byte)nudBlue.Value, (byte)nudAlpha.Value); }
            set
            {
                nudRed.Value = value.R;
                nudGreen.Value = value.G;
                nudBlue.Value = value.B;
                nudAlpha.Value = value.A;
                this.pbPreview.Invalidate();
            }
        }

        public ColorVisualizerForm()
        {
            InitializeComponent();
        }

        private void pbPreview_Click(object sender, EventArgs e)
        {
            if (ColorDialog1.ShowDialog() == DialogResult.OK)
            {
                System.Drawing.Color c = ColorDialog1.Color;
                this.Color = new Color(c.R, c.G, c.B, c.A);
            }
        }

        private void pbPreview_Paint(object sender, PaintEventArgs e)
        {
            System.Drawing.Brush[] colors = new System.Drawing.Brush[2];
            int cw = (int)(e.ClipRectangle.Width * 0.025f);
            int ch = (int)(e.ClipRectangle.Height * 0.025f);
            int index = 0;
            colors[0] = Brushes.White;
            colors[1] = Brushes.Black;

            for (int idx = 0; idx < e.ClipRectangle.Width; idx += cw)
            {
                for (int idy = 0; idy < e.ClipRectangle.Height; idy += ch)
                {
                    System.Drawing.Rectangle r = new System.Drawing.Rectangle(idx, idy, cw, ch);
                    e.Graphics.FillRectangle(colors[index], r);
                    index = index + 1 > 1 ? 0 : 1;
                }
            }

            System.Drawing.Color c = System.Drawing.Color.FromArgb((byte)nudAlpha.Value, (byte)nudRed.Value, (byte)nudGreen.Value, (byte)nudBlue.Value);
            e.Graphics.FillRectangle(new SolidBrush(c), e.ClipRectangle);
        }

        private void btnCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void nudValuesChanged(object sender, EventArgs e)
        {
            this.pbPreview.Invalidate();
        }
    }

}
