﻿/*
Created by: X
http://www.createdbyx.com/

This work is licensed under a Creative Commons Attribution-Noncommercial-Share Alike 2.5 Canada License 
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/. 
Permissions beyond the scope of this license may be available at http://contact.createdbyx.com/.
*/
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.VisualStudio.DebuggerVisualizers;

[assembly: DebuggerVisualizer(typeof(XNAVisies.MatrixVisualizer), Target = typeof(Microsoft.Xna.Framework.Matrix), Description = "XNAVisies: Matrix Visualizer")]

namespace XNAVisies
{
 // TODO: Add the following to SomeType's definition to see this visualizer when debugging instances of SomeType:
 //
 // [DebuggerVisualizer(typeof(MatrixVisualizer))]
 // [Serializable]
 // public class SomeType
 // {
 // ...
 // }
 //
 /// <summary>
 /// A Visualizer for SomeType.
 /// </summary>
 public class MatrixVisualizer : DialogDebuggerVisualizer
 {
    
     protected override void Show(IDialogVisualizerService windowService, IVisualizerObjectProvider objectProvider)
     {
         // TODO: Get the object to display a visualizer for.
         // Cast the result of objectProvider.GetObject()
         // to the type of the object being visualized.
         Microsoft.Xna.Framework.Matrix matrix = (Microsoft.Xna.Framework.Matrix)objectProvider.GetObject();
         float[] values = new float[17];
         values[0] = matrix.M11;
         values[1] = matrix.M12;
         values[2] = matrix.M13;
         values[3] = matrix.M14;
         values[4] = matrix.M21;
         values[5] = matrix.M22;
         values[6] = matrix.M23;
         values[7] = matrix.M24;
         values[8] = matrix.M31;
         values[9] = matrix.M32;
         values[10] = matrix.M33;
         values[11] = matrix.M34;
         values[12] = matrix.M41;
         values[13] = matrix.M42;
         values[14] = matrix.M43;
         values[15] = matrix.M44;
        
         // Show the same number of decimal places for all matrix elements,
         // but don't show any more than necessary to represent all values.
        
         int numFracDigitsMax = 1;
         // show at least one fractional digit
        
       //  float f = 0;
         foreach (var f in values) {
             float fTest = Math.Abs(f);
             fTest = fTest - (float)Math.Floor(fTest);
             string strTest = f.ToString();
             int numFracDigits = strTest.Length - 2;
             // subtract the "0."
             numFracDigitsMax = Math.Max(numFracDigits, numFracDigitsMax);
         }
        
         string stringFormat = string.Format("f{0}", numFracDigitsMax);
        
        
         // TODO: Display your view of the object.
         // Replace displayForm with your own custom Form or Control.
         using (MatrixVisualizerForm displayForm = new MatrixVisualizerForm()) {
            
             Control[] labels = new Control[17];
             labels[0] = displayForm.tableLayoutPanel.Controls["label1"];
             labels[1] = displayForm.tableLayoutPanel.Controls["label2"];
             labels[2] = displayForm.tableLayoutPanel.Controls["label3"];
             labels[3] = displayForm.tableLayoutPanel.Controls["label4"];
             labels[4] = displayForm.tableLayoutPanel.Controls["label5"];
             labels[5] = displayForm.tableLayoutPanel.Controls["label6"];
             labels[6] = displayForm.tableLayoutPanel.Controls["label7"];
             labels[7] = displayForm.tableLayoutPanel.Controls["label8"];
             labels[8] = displayForm.tableLayoutPanel.Controls["label9"];
             labels[9] = displayForm.tableLayoutPanel.Controls["label10"];
             labels[10] = displayForm.tableLayoutPanel.Controls["label11"];
             labels[11] = displayForm.tableLayoutPanel.Controls["label12"];
             labels[12] = displayForm.tableLayoutPanel.Controls["label13"];
             labels[13] = displayForm.tableLayoutPanel.Controls["label14"];
             labels[14] = displayForm.tableLayoutPanel.Controls["label15"];
             labels[15] = displayForm.tableLayoutPanel.Controls["label16"];
            
             for (int i = 0; i <= 15; i++) {
                 labels[i].Text = values[i].ToString(stringFormat);
                 if (values[i] == 0f) {
                     labels[i].ForeColor = System.Drawing.SystemColors.GrayText;
                 }
             }
            
             // assign the matrix
             displayForm.Matrix = matrix;

             if (windowService.ShowDialog(displayForm) == DialogResult.OK)
             {
                 // update object values
                 objectProvider.ReplaceObject(displayForm.Matrix);
             }
         }
     }
    
     // TODO: Add the following to your testing code to test the visualizer:
     //
     // MatrixVisualizer.TestShowVisualizer(new SomeType());
     //
     /// <summary>
     /// Tests the visualizer by hosting it outside of the debugger.
     /// </summary>
     /// <param name="objectToVisualize">The object to display in the visualizer.</param>
     public static void TestShowVisualizer(object objectToVisualize)
     {
         VisualizerDevelopmentHost visualizerHost = new VisualizerDevelopmentHost(objectToVisualize, typeof(MatrixVisualizer));
         visualizerHost.ShowVisualizer();
     }
 }

}
