﻿/*
Created by: X
http://www.createdbyx.com/

This work is licensed under a Creative Commons Attribution-Noncommercial-Share Alike 2.5 Canada License 
http://creativecommons.org/licenses/by-nc-sa/2.5/ca/. 
Permissions beyond the scope of this license may be available at http://contact.createdbyx.com/.
*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Vector3 = Microsoft.Xna.Framework.Vector3;

namespace XNAVisies
{
    public partial class MatrixVisualizerForm : Form
    {


        private Microsoft.Xna.Framework.Matrix mobjMatrix;

        public Microsoft.Xna.Framework.Matrix Matrix
        {
            get { return mobjMatrix; }
            set
            {
                mobjMatrix = value;
                Vector3 T = default(Vector3);
                Vector3 S = default(Vector3);
                Microsoft.Xna.Framework.Matrix R = default(Matrix);

                MatrixDecompose(value, out T, out S, out R);
                txtPosX.Text = T.X.ToString();
                txtPosY.Text = T.Y.ToString();
                txtPosZ.Text = T.Z.ToString();

                //txtRotX.text = CDec(mobjMatrix.M41)
                //txtRotY.text = CDec(mobjMatrix.M42)
                //txtRotZ.text = CDec(mobjMatrix.M43)

                txtScaleX.Text = T.X.ToString();
                txtScaleY.Text = T.Y.ToString();
                txtScaleZ.Text = T.Z.ToString();
            }
        }



        public void MatrixDecompose(Matrix mat, out Vector3 vTrans, out Vector3 vScale, out Matrix mRot)
        {
            vTrans = Vector3.Zero;
            vScale = Vector3.Zero;
            mRot = Matrix.Identity;

            Vector3[] vCols = new Vector3[] { new Vector3(mat.M11, mat.M12, mat.M13), new Vector3(mat.M21, mat.M22, mat.M23), new Vector3(mat.M31, mat.M32, mat.M33) };

            vScale.X = vCols[0].Length();
            vScale.Y = vCols[1].Length();
            vScale.Z = vCols[2].Length();


            vTrans.X = mat.M41 / (float)(vScale.X == 0 ? 1 : vScale.X);
            vTrans.Y = mat.M42 / (float)(vScale.Y == 0 ? 1 : vScale.Y);
            vTrans.Z = mat.M43 / (float)(vScale.Z == 0 ? 1 : vScale.Z);

            if (vScale.X != 0)
            {
                vCols[0].X /= vScale.X;
                vCols[0].Y /= vScale.X;
                vCols[0].Z /= vScale.X;
            }
            if (vScale.Y != 0)
            {
                vCols[1].X /= vScale.Y;
                vCols[1].Y /= vScale.Y;
                vCols[1].Z /= vScale.Y;
            }
            if (vScale.Z != 0)
            {
                vCols[2].X /= vScale.Z;
                vCols[2].Y /= vScale.Z;
                vCols[2].Z /= vScale.Z;
            }

            mRot.M11 = vCols[0].X;
            mRot.M12 = vCols[0].Y;
            mRot.M13 = vCols[0].Z;
            mRot.M14 = 0;
            mRot.M41 = 0;
            mRot.M21 = vCols[1].X;
            mRot.M22 = vCols[1].Y;
            mRot.M23 = vCols[1].Z;
            mRot.M24 = 0;
            mRot.M42 = 0;
            mRot.M31 = vCols[2].X;
            mRot.M32 = vCols[2].Y;
            mRot.M33 = vCols[2].Z;
            mRot.M34 = 0;
            mRot.M43 = 0;
            mRot.M44 = 1;
        }


        public MatrixVisualizerForm()
        {
            InitializeComponent();
        }

        private void txtCmd_KeyUp(object sender, KeyEventArgs e)
        {
            ExecuteCommand(txtCmd.Text);
        }

        private void ExecuteCommand(string text)
        {

        }
    }
}
